# OpKills.tcl v0.1 by masterT
#
# Notes
# -> This tcl will ONLY work on 2.10.x ircds (hence: not on EFNet, but on IRCNet)
# -> you should add the string to the init-server variable in the eggdrop-conf
#  >  ;putserv "JOIN &KILLS"      
#  > Your string should then look something like this ->
#  > set init-server { putserv "MODE $botnick +iw" ;putserv "JOIN &KILLS" }
# -> you should add channel &kills manually ie: .+chan &kills, since the checkroutines
#  > for &-chans (still?) seem to be buggy
#
# >> If you find any bugs or have any wishes for something to be added feel free
# >> to email me at masterT@topmail.de
#
# Thanks to smartguy & all the opers for testing >:)
#
# Todo:
# + optional logging of server and/or operkills/verbose kills
# + mass-server-kill (collides etc) detection
# + different counters for matched/nonmatched oper/server kills
# + anounce for total kills (instead of server OR operkills)
# + fix the support for not resetting the stats on a rehash
#
# Version-History:
# + 0.1v the basic stuff (Public release: 09.03.2001)
#
############
# Settings #
############
#
# What should trigger the kill-statistics output?
set trigger "!killstats"
# Send kill-statistics to nick or whole chan? (0/nick 1/chan)
# Recommended value: 1
set output2 1
# What chan should operkills be announced to? (note without: # at the front)
set opkchan "yourchannel"
# What kills to display to the channel (0/none 1/verbose
# 2/verbose+operkills 3/verbose+serverkills 4/verbose+allkills 5/serverkills
# 6/operkills 7/operkills+serverkills)
# Recommended value: 2
set opkwk 2
# Set anounce every 1000 kills? (0/none 1/server-only 2/oper-only 3/all)
# Recommended value: 3
set opkan 3
# Activate matched-kills-verbose-output-feature (0/off 1/on)
# (dont touch if you dont understand what this does!)
set opkvs 1
# Use matched kills for server/oper/all-kills? (0/all 1/opers 2/servers)
set opkw 0
# Set your hosts/identds/nicks/servers (keep server-masking in mind!) for verbose output
# Note: Dont remove the list at the front!
set opkv "[list someoper someserver somehost]"
# # # # # #
# c o d e #
# # # # # #
set opkv [string tolower $opkv]
set opkver "v0.1"
if ![info exists upkload] {
 putlog "OpKills.tcl> First load, resetting."
 set opkload [unixtime]
 set killnum 0
 set opkill 0
} else {putlog "OpKills.tcl> Data exists, not resetting."}
bind notc -  *  parse_kills
bind pub - "[string tolower [lindex $trigger 0]]" pub_kstats
proc pub_kstats {nick uhost hand chan args} {
 global opkchan opkload killnum opkill output2
 if {([lindex $output2 0]!="0") && ([lindex $output2 0]!="1")} {
  putlog "OpKills.tcl> Error killstats-output->wrong or no value!"
  putlog "OpKills.tcl> Using default (output to channel)"
  set output2 1
 }
 switch -exact -- $output2 {
  0 {set dest [lindex $nick 0]}
  1 {set dest [lindex $chan 0]}
 } 
 putlog "!$nick! Kill-Stats"
 putserv "PRIVMSG $dest :Oper-Kills: $opkill Server-Kills: $killnum"
 putserv "PRIVMSG $dest :Total of [expr $opkill+$killnum] in [duration [expr [unixtime]-$opkload]]"
 return 0
}
proc parse_kills {nick uhost hand chan text {dest ""}} {
 global opkchan killnum opkload server opkill opkvs opkv opkw opkwk opkan
 if {[string tolower $text]!="&kills"} {return 0}
 if {[string tolower $uhost]!=[string range $server 0 [expr [string last ":" $server]-1]]} {
  return 0
 } else {
  if {[string last . [lindex $chan 6]]>="0"} {
   set killnum [expr 1+$killnum]
   if {($opkan==1)||($opkan==3)} {
    if {[string range $killnum [expr [string length $killnum]-3] end]=="000"} {
     putserv "PRIVMSG #$opkchan :\002 $killnum th server-kill!\002"
    }
   }
   set target [string range [lindex $chan 4] 0 [expr [string length [lindex $chan 4]]-2]]
   set oper [lindex $chan 6]
   set reason [lrange $chan 9 end]
   set path [string tolower [lrange $chan 8 8]]
   if {($opkwk==1)||($opkwk==2)||($opkwk==3)||($opkwk==4)} {
    if {([lindex $opkvs 0]=="1")&&(($opkw=="2")||($opkw=="0"))} {
     foreach item "$opkv" {
      if {[string last $item $path]>=0} {
       putserv "PRIVMSG #$opkchan :\002wh00pa! $item \002-> $oper killed $target $reason"
       return 0
      }  
     }
    }
   }
   if {($opkwk==3)||($opkwk==4)||($opkwk==5)||($opkwk==7)} {
    putserv "PRIVMSG #$opkchan :Server $oper killed $target $reason"
    return 0
   }
   return 0
  } else {
   set opkill [expr 1+$opkill]
   if {($opkan==2)||($opkan==3)} {
    if {[string range $opkill [expr [string length $killnum]-3] end]=="000"} {
     putserv "PRIVMSG #$opkchan :\002 $opkill th oper-kill!\002"
    }
   }
   set target [string range [lindex $chan 4] 0 [expr [string length [lindex $chan 4]]-2]]
   set oper [lindex $chan 6]
   set path [string tolower [lrange $chan 8 8]]
   set reason [lrange $chan 9 end]
   if {($opkwk==1)||($opkwk==2)||($opkwk==3)||($opkwk==4)} {
    if {([lindex $opkvs 0]=="1")&&(($opkw=="1")||($opkw=="0"))} {
     foreach item "$opkv" {
      if {[string last [lindex [string tolower $item] 0] [string tolower $path]]>="0"} {
       putserv "PRIVMSG #$opkchan :\002wh00pa! $item \002-> $oper killed $target $reason"
       return 0
      }  
     }
    }
   }
   if {($opkwk==2)||($opkwk==4)||($opkwk==6)||($opkwk==7)} {
    putserv "PRIVMSG #$opkchan :b0mb0m! Kill for $target from $oper $reason"
    return 0
   }
   return 0
  }
  return 0
 }
}
putserv "JOIN &KILLS"
putlog "OpKills $opkver by masterT loaded, output to \#$opkchan"
# eof